#include "main.h"
#include "levels.h"

// Set the level groups
char level_group_name[NUM_OF_LEVEL_GROUPS][30] = { "Training Levels", "Robin Ohm's Levels", "Box Levels" };
int level_group_start[3] = { 1, 4, 16 };
int level_group_end[3] = { 3, 15, 22 };

void loadLevel(int lid) {
	int x, y;
	if (!load_curr_level) {
		Robot_level = lid;
		for (y = 0; y < 12; y++) {
			for (x = 0; x < 16; x++) {
				curr_level[y][x] = level[lid][y][x];
				putTile(level[lid][y][x], x * TILE_SIZE, y * TILE_SIZE, SCREEN_TOP);
				if (level[lid][y][x] > 2 && level[lid][y][x] < 7) {
					Robot_x = x;
					Robot_y = y;
					Robot_direction = level[lid][y][x] - 2;
					Robot_item = 2;
				}
			}
		}
	} else {
		for (y = 0; y < 12; y++) {
			for (x = 0; x < 16; x++) {
				curr_level[y][x] = curr_custom_level[y][x];
				putTile(curr_custom_level[y][x], x * TILE_SIZE, y * TILE_SIZE, SCREEN_TOP);
				if (curr_custom_level[y][x] > 2 && curr_custom_level[y][x] < 7) {
					Robot_x = x;
					Robot_y = y;
					Robot_direction = curr_custom_level[y][x] - 2;
					Robot_item = 2;
				}
			}
		}
	}
	
	// Item box
	for (x = 210; x < 228; x++) {
		putPixel2(8, x, 15, SCREEN_BOTTOM);
		putPixel2(8, x, 32, SCREEN_BOTTOM);
	}
	for (y = 15; y < 33; y++) {
		putPixel2(8, 210, y, SCREEN_BOTTOM);
		putPixel2(8, 227, y, SCREEN_BOTTOM);
	}
	putTile(Robot_item, 211, 16, SCREEN_BOTTOM);
	printString("Item", 201, 5, SCREEN_BOTTOM);
	
	// Program "window"
	for (x = 15; x < 100; x++) {
		putPixel2(12, x, 15, SCREEN_BOTTOM);
		putPixel2(12, x, 75, SCREEN_BOTTOM);
	}
	for (y = 16; y < 75; y++) {
		putPixel2(2, 75, y, SCREEN_BOTTOM);
		putPixel2(12, 15, y, SCREEN_BOTTOM);
		putPixel2(12, 100, y, SCREEN_BOTTOM);
	}
	printString("Program", 30, 5, SCREEN_BOTTOM);
}

// Used for debugging
void updateLevel(int lid) {
	int x, y;
	for (y = 0; y < 12; y++) {
		for (x = 0; x < 16; x++) {
			putTile(level[lid][y][x], x * TILE_SIZE, y * TILE_SIZE);
		}
	}
}

int level[NUM_OF_LEVELS][12][16] = {
/*
	// Level template
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
*/

	// 0
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},

	// 1
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,14,2,2,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,2,2,2,2,13,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,2,2,6,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 2
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,19,2,2,2,2,2,2,2,20,0,0,0,0 },
		{ 0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,2,3,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0 },
		{ 0,0,0,13,16,2,2,2,2,2,15,14,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 3
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,2,2,24,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,0,24,2,0,0,0,0,0,0,2,2,0,0,0 },
		{ 0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0 },
		{ 0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0 },
		{ 0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0 },
		{ 0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0 },
		{ 0,0,0,2,2,0,0,0,0,0,0,1,2,0,0,0 },
		{ 0,0,0,2,24,2,2,13,2,2,6,1,14,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 4
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,21,2,2,2,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,1,1,1,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,1,14,1,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,1,17,1,2,1,16,1,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,2,1,13,1,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,2,1,1,1,2,2,2,0,0,0 },
		{ 0,0,2,2,2,3,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,2,2,8,2,2,2,2,2,2,20,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 5
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,2,2,2,2,2,2,2,13,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,2,2,2,2,2,2,14,0,0,0 },
		{ 0,0,1,18,1,1,1,1,1,1,1,1,1,0,0,0 },
		{ 0,0,2,2,2,2,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,22,2,2,2,2,2,2,0,0,0 },
		{ 0,0,1,1,1,1,1,1,1,1,1,16,1,0,0,0 },
		{ 0,0,2,2,2,2,2,2,2,2,2,20,2,0,0,0 },
		{ 0,0,7,4,2,2,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 6
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,2,19,2,2,2,1,2,13,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,2,15,2,2,2,2,14,0,0,0 },
		{ 0,0,1,18,1,1,1,1,1,1,1,1,1,0,0,0 },
		{ 0,0,2,2,2,2,2,1,2,2,2,21,2,0,0,0 },
		{ 0,0,2,2,2,2,22,17,2,2,2,2,2,0,0,0 },
		{ 0,0,1,1,1,1,1,1,1,1,1,16,1,0,0,0 },
		{ 0,0,2,2,2,2,2,1,2,2,2,20,2,0,0,0 },
		{ 0,0,7,4,2,2,2,1,2,2,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 7
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,2,2,2,2,2,1,14,2,13,2,2,0,0,0 },
		{ 0,0,2,1,1,1,1,1,1,1,1,1,2,0,0,0 },
		{ 0,0,2,1,2,21,1,1,1,20,2,16,2,0,0,0 },
		{ 0,0,2,1,2,15,2,1,2,17,2,1,2,0,0,0 },
		{ 0,0,2,1,1,22,2,18,2,2,1,1,2,0,0,0 },
		{ 0,0,2,1,2,2,2,1,2,2,19,1,2,0,0,0 },
		{ 0,0,2,1,1,2,1,1,1,1,1,1,2,0,0,0 },
		{ 0,0,7,4,2,2,2,1,2,2,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 8
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,13,2,1,1,14,1,1,2,21,20,22,0,0,0 },
		{ 0,0,2,2,17,2,2,2,1,2,2,2,2,0,0,0 },
		{ 0,0,2,2,1,2,2,2,1,2,2,2,2,0,0,0 },
		{ 0,0,2,2,1,1,1,1,1,2,2,2,2,0,0,0 },
		{ 0,0,2,2,1,1,1,1,2,2,2,2,2,0,0,0 },
		{ 0,0,2,2,1,2,2,2,1,2,2,2,2,0,0,0 },
		{ 0,0,2,2,1,2,2,2,1,2,2,2,3,0,0,0 },
		{ 0,0,2,2,16,2,2,2,18,2,2,2,8,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 9
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,23,13,15,2,23,21,23,20,23,22,23,0,0,0 },
		{ 0,0,19,2,2,2,2,2,2,2,2,2,19,0,0,0 },
		{ 0,0,16,23,16,23,18,23,2,23,2,23,2,0,0,0 },
		{ 0,0,2,2,2,2,2,17,2,2,2,2,2,0,0,0 },
		{ 0,0,23,2,2,2,23,2,23,16,17,18,15,0,0,0 },
		{ 0,0,2,2,2,2,2,23,2,2,2,2,2,0,0,0 },
		{ 0,0,2,23,21,23,2,23,2,2,2,2,16,0,0,0 },
		{ 0,0,6,7,23,2,20,23,20,2,2,23,14,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 10
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,1,13,1,2,1,2,1,19,1,2,8,0,0,0 },
		{ 0,0,14,2,17,2,2,2,16,2,2,2,5,0,0,0 },
		{ 0,0,1,2,1,2,1,2,1,2,1,2,2,0,0,0 },
		{ 0,0,1,2,1,2,1,2,1,2,1,2,2,0,0,0 },
		{ 0,0,1,2,1,2,2,2,1,2,1,2,2,0,0,0 },
		{ 0,0,1,2,1,2,2,2,1,2,1,2,2,0,0,0 },
		{ 0,0,1,2,1,2,21,2,1,2,1,2,2,0,0,0 },
		{ 0,0,1,2,16,20,2,2,1,2,18,22,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 11
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,8,1,2,1,1,1,1,22,2,1,2,0,0,0 },
		{ 0,0,5,1,2,21,2,2,2,2,2,18,2,0,0,0 },
		{ 0,0,2,1,2,1,2,2,2,2,2,1,2,0,0,0 },
		{ 0,0,2,1,2,1,1,1,1,1,2,1,2,0,0,0 },
		{ 0,0,2,1,2,2,2,2,2,1,2,1,17,0,0,0 },
		{ 0,0,2,2,15,2,2,2,2,16,2,1,13,0,0,0 },
		{ 0,0,2,1,2,2,2,2,2,1,2,1,2,0,0,0 },
		{ 0,0,19,1,2,20,1,1,1,1,2,1,14,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 12
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,2,2,20,2,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,2,1,1,1,1,1,1,1,1,1,2,0,0,0 },
		{ 0,0,2,1,13,2,2,1,18,2,2,1,2,0,0,0 },
		{ 0,0,16,1,14,17,21,2,2,1,2,1,2,0,0,0 },
		{ 0,0,2,1,1,1,1,1,1,1,2,1,15,0,0,0 },
		{ 0,0,2,2,2,2,2,2,2,2,22,1,2,0,0,0 },
		{ 0,0,1,1,1,1,1,1,1,1,1,1,2,0,0,0 },
		{ 0,0,7,4,2,2,2,2,2,19,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 13
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,18,2,2,2,2,13,2,20,2,2,16,0,0,0 },
		{ 0,0,2,1,2,1,1,14,1,1,2,1,2,0,0,0 },
		{ 0,0,2,1,2,1,1,17,1,1,2,1,2,0,0,0 },
		{ 0,0,22,1,1,1,1,21,1,1,1,1,2,0,0,0 },
		{ 0,0,2,1,1,1,1,2,1,1,1,1,2,0,0,0 },
		{ 0,0,2,1,1,1,1,18,1,1,1,1,19,0,0,0 },
		{ 0,0,3,1,1,1,1,2,1,1,1,1,2,0,0,0 },
		{ 0,0,8,1,1,1,1,22,22,2,2,2,15,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 14
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,14,18,2,2,2,1,2,22,20,17,13,0,0,0 },
		{ 0,0,18,2,2,2,2,1,2,2,2,2,16,0,0,0 },
		{ 0,0,2,2,2,2,2,16,2,2,2,2,2,0,0,0 },
		{ 0,0,2,1,2,1,2,1,2,1,2,1,2,0,0,0 },
		{ 0,0,1,21,1,2,1,1,1,2,17,2,1,0,0,0 },
		{ 0,0,2,2,2,2,2,1,2,2,2,2,2,0,0,0 },
		{ 0,0,3,2,2,2,2,16,2,2,2,2,2,0,0,0 },
		{ 0,0,8,2,20,2,2,1,2,21,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 15
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,1,1,1,7,4,2,1,1,1,1,1,0,0,0 },
		{ 0,0,1,1,1,1,1,2,1,1,1,1,1,0,0,0 },
		{ 0,0,1,1,1,1,1,19,1,1,1,1,1,0,0,0 },
		{ 0,0,1,1,1,1,1,2,1,1,1,1,1,0,0,0 },
		{ 0,0,13,19,18,15,2,2,2,2,17,16,14,0,0,0 },
		{ 0,0,1,1,1,1,1,20,1,1,1,1,1,0,0,0 },
		{ 0,0,1,1,1,1,1,22,1,1,1,1,1,0,0,0 },
		{ 0,0,1,1,1,1,1,21,1,1,1,1,1,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 16
	{
		{ 0,0,0,0,0,13,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,24,2,0,0,0,0,0,0,0,0,2 },
		{ 0,0,0,2,1,2,2,2,0,0,0,0,0,0,2,2 },
		{ 0,0,2,1,2,2,2,2,1,0,0,0,0,2,2,2 },
		{ 0,23,23,2,2,2,1,2,1,2,0,0,2,2,24,2 },
		{ 4,2,23,2,1,2,1,2,2,2,17,24,2,2,24,2 },
		{ 0,2,2,2,2,2,1,2,2,2,0,0,2,2,24,2 },
		{ 0,0,2,2,1,2,2,2,22,0,0,0,0,2,2,18 },
		{ 0,0,0,2,1,2,2,21,0,0,0,0,0,0,2,2 },
		{ 0,0,0,0,1,2,2,0,0,0,0,0,0,0,0,14 },
		{ 0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 17
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,1,14,1,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,1,13,1,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,1,2,2,2,1,0,0,0,0,0 },
		{ 0,0,0,0,0,0,1,24,24,24,1,0,0,0,0,0 },
		{ 0,0,0,0,0,0,1,2,2,2,1,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,1,2,1,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,1,3,1,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 18
	{
		{ 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2 },
		{ 2,1,24,1,1,1,1,1,1,1,1,1,1,24,1,2 },
		{ 2,24,2,2,2,2,2,2,2,2,2,2,2,2,1,2 },
		{ 2,1,2,1,24,1,1,1,1,1,1,1,1,2,1,2 },
		{ 2,1,2,24,2,2,2,2,2,16,2,20,24,2,1,2 },
		{ 2,1,2,1,2,1,14,1,1,2,1,2,1,2,1,2 },
		{ 2,1,2,1,2,1,2,1,1,13,1,2,1,2,1,2 },
		{ 2,1,2,24,19,2,15,2,2,2,2,2,24,2,1,2 },
		{ 2,1,2,1,24,1,1,1,1,1,1,24,1,2,1,2 },
		{ 2,24,2,2,2,2,2,2,2,2,2,2,2,2,24,2 },
		{ 2,1,24,1,1,1,1,1,1,1,1,1,1,24,1,2 },
		{ 2,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2 }
	},
	
	// 19
	{
		{ 14,2,24,2,2,2,0,0,0,0,0,0,0,0,0,0 },
		{ 0,2,24,2,24,0,0,19,0,0,0,0,0,0,0,0 },
		{ 0,2,2,2,2,0,2,2,2,0,13,1,2,0,0,0 },
		{ 0,0,2,2,2,0,2,2,2,0,2,1,2,0,0,0 },
		{ 0,0,2,2,2,0,2,2,24,0,15,2,2,0,0,0 },
		{ 0,0,2,0,24,0,24,0,2,0,2,0,24,0,0,0 },
		{ 0,0,2,2,2,0,2,2,2,0,2,2,2,0,0,0 },
		{ 0,0,24,0,0,0,0,0,24,0,24,0,0,0,0,0 },
		{ 0,0,2,2,2,0,2,2,2,0,2,2,2,0,0,0 },
		{ 0,0,2,2,2,2,2,3,2,2,2,2,2,0,0,0 },
		{ 0,0,2,2,2,0,2,2,2,0,2,2,2,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 20
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,2,24,2,24,2,2,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,19,2,21,2,13,0,0,0,0,0,0 },
		{ 0,0,0,0,0,22,2,20,2,2,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,2,24,2,24,2,2,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	},
	
	// 21
	{
		{ 24,2,2,2,24,2,24,24,2,2,2,24,24,2,24,24 },
		{ 24,2,24,24,24,2,24,14,24,24,24,2,24,2,24,24 },
		{ 2,24,2,24,24,2,2,24,2,2,24,2,24,24,24,2 },
		{ 24,24,24,24,24,2,2,24,2,2,2,24,2,24,24,24 },
		{ 24,2,24,24,24,24,24,24,2,2,24,24,24,2,2,24 },
		{ 24,24,2,24,24,24,24,24,24,24,2,24,2,2,2,24 },
		{ 24,24,24,24,24,24,24,2,2,2,2,24,2,2,2,24 },
		{ 24,24,24,2,24,24,2,2,2,2,2,24,24,2,2,2 },
		{ 24,2,24,24,2,2,24,24,24,24,24,24,2,2,2,24 },
		{ 2,24,2,2,2,24,2,2,2,2,24,2,2,2,24,2 },
		{ 24,24,2,24,24,2,24,2,2,2,24,24,24,24,2,2 },
		{ 4,2,2,2,24,2,24,2,24,2,24,2,2,2,2,13 }
	},
	
	// 22
	{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,2,14,2,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0 },
		{ 0,0,0,0,16,0,2,2,2,0,0,0,0,0,0,0 },
		{ 0,0,0,0,2,2,2,2,2,2,2,2,2,0,0,0 },
		{ 0,0,0,0,2,0,2,13,2,0,0,0,2,0,0,0 },
		{ 0,0,0,0,2,0,0,2,0,2,2,2,2,0,0,0 },
		{ 0,0,0,20,2,2,2,2,0,2,2,2,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,4,2,2,0,0,0,0 },
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
	}
};
